/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"


#define Sine_Wave_LENGTH   100

const uint32 CYCODE Sine_Wave[Sine_Wave_LENGTH] = { 128u,135u,143u,151u,159u,166u,174u,181u,188u,194u,201u,207u,213u,219u,224u,229u,233u,237u,241u,244u,246u,249u,250u,252u,252u,252u,252u,252u,250u,249u,246u,244u,241u,237u,233u,229u,224u,219u,213u,207u,201u,194u,188u,181u,174u,166u,159u,151u,143u,135u,128u,120u,112u,104u,96u,89u,81u,74u,67u,61u,54u,48u,42u,36u,31u,26u,22u,18u,14u,11u,9u,6u,5u,3u,3u,3u,3u,3u,5u,6u,9u,11u,14u,18u,22u,26u,31u,36u,42u,48u,54u,61u,67u,74u,81u,89u,96u,104u,112u,120u };
uint32  Sine_Wave_data[Sine_Wave_LENGTH];

int main(void)
{
    uint8   i;
    uint8   Centroid_pos;
    uint8   New_PWM_Period;

    CyGlobalIntEnable; /* Enable global interrupts. */
    IDAC_Start();
//    Opamp_Start();
    
  
    
    
    DMA_IDAC_Start((void *) &Sine_Wave_data[0], (void *)IDAC_IDAC_CONTROL_PTR);

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    
    for (i=0; i < Sine_Wave_LENGTH ; i++)
    {
        Sine_Wave_data[i] = ((IDAC_IDAC_CONTROL_REG & (~(uint32)IDAC_CURRENT_VALUE_MASK)) | (Sine_Wave[i]>>1));
    }  
    
    Opamp_Start();
    PWM_TRIG_Start();
    
    /* Start EZI2C block */
    EZI2C_Start();
    
    /* Set up communication data buffer to CapSense data structure to be exposed to 
    I2C master at primary slave address request. */
    EZI2C_EzI2CSetBuffer1(sizeof(CapSense_dsRam), sizeof(CapSense_dsRam), 
                         (uint8 *)&CapSense_dsRam);
    
    /* Start CapSense block - Initializes CapSense Data structure and 
    performs first scan to set up sensor baselines */
    CapSense_Start();

        /* Scan all widgets */
    CapSense_ScanAllWidgets();
    
    for(;;)
    {
        /* Do this only when a scan is done */
        if(CapSense_NOT_BUSY == CapSense_IsBusy())
        {
              /* Process all widgets */
              CapSense_ProcessAllWidgets();
              /* Include Tuner */ 
              CapSense_RunTuner(); 
              /* Scan result verification */
              if (CapSense_IsAnyWidgetActive())
              {
                Centroid_pos = (uint8)CapSense_GetCentroidPos(CapSense_LINEARSLIDER0_WDGT_ID);
                if (Centroid_pos < 2)
                {
                    New_PWM_Period = 2;
                }
                else
                {
                    New_PWM_Period = Centroid_pos;
                }
   
                PWM_TRIG_WritePeriod(New_PWM_Period);
              }
              /* Start next scan */
              CapSense_ScanAllWidgets();
        }
    }
 }

/* [] END OF FILE */
